summaryrefslogtreecommitdiffstats
path: root/libexec/container
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@open-infrastructure.net>2021-07-26 11:27:56 +0000
committerDaniel Baumann <daniel.baumann@open-infrastructure.net>2021-07-27 00:31:53 +0000
commit5323d07b2ce9416e5958be415c35220cce3b4114 (patch)
tree60ad17be121c5473857d8ff9f22bb384211df5bc /libexec/container
parentCorrecting synopsis in container-run manpage. (diff)
downloadcompute-tools-5323d07b2ce9416e5958be415c35220cce3b4114.tar.xz
compute-tools-5323d07b2ce9416e5958be415c35220cce3b4114.zip
Adding container update command.
Signed-off-by: Daniel Baumann <daniel.baumann@open-infrastructure.net>
Diffstat (limited to 'libexec/container')
-rwxr-xr-xlibexec/container/update143
1 files changed, 143 insertions, 0 deletions
diff --git a/libexec/container/update b/libexec/container/update
new file mode 100755
index 0000000..bb175d1
--- /dev/null
+++ b/libexec/container/update
@@ -0,0 +1,143 @@
+#!/bin/sh
+
+# Copyright (C) 2014-2021 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+set -e
+
+PROJECT="open-infrastructure"
+SOFTWARE="compute-tools"
+PROGRAM="container"
+COMMAND="$(basename ${0})"
+
+HOOKS="/etc/${SOFTWARE}/hooks"
+
+Parameters ()
+{
+ GETOPT_LONGOPTIONS="name:,full-upgrade,autoremove,purge,yes,"
+ GETOPT_OPTIONS="n:,r,p,y,"
+
+ PARAMETERS="$(getopt --longoptions ${GETOPT_LONGOPTIONS} --name=${COMMAND} --options ${GETOPT_OPTIONS} --shell sh -- ${@})"
+
+ if [ "${?}" != "0" ]
+ then
+ echo "'${COMMAND}': getopt exit" >&2
+ exit 1
+ fi
+
+ eval set -- "${PARAMETERS}"
+
+ while true
+ do
+ case "${1}" in
+ -n|--name)
+ NAME="${2}"
+ shift 2
+ ;;
+
+ -f|--full-upgrade)
+ FULL_UPGRADE="true"
+ shift 1
+ ;;
+
+ -r|--autoremove)
+ AUTOREMOVE="true"
+ shift 1
+ ;;
+
+ -p|--purge)
+ PURGE="--purge"
+ shift 1
+ ;;
+
+ -y|--yes)
+ YES="-y"
+ shift 1
+ ;;
+
+ --)
+ shift 1
+ break
+ ;;
+
+ *)
+ echo "'${COMMAND}': getopt error" >&2
+ exit 1
+ ;;
+ esac
+ done
+}
+
+Usage ()
+{
+ echo "Usage: ${PROGRAM} ${COMMAND} -n|--name NAME [-f|--full-upgrade] [-r|--autoremove] [-p|--purge] [-y|--yes]" >&2
+ exit 1
+}
+
+Parameters "${@}"
+
+case "${NAME}" in
+ ALL)
+ NAMES="$(container list --started --format shell)"
+ ;;
+
+ *)
+ NAMES="${NAME}"
+ ;;
+esac
+
+# Pre hooks
+for FILE in "${HOOKS}/pre-${COMMAND}".* "${HOOKS}/${NAME}.pre-${COMMAND}"
+do
+ if [ -x "${FILE}" ]
+ then
+ "${FILE}"
+ fi
+done
+
+# Run
+for NAME in ${NAMES}
+do
+ echo "################################################################################"
+ echo "Updating ${NAME}"
+ echo "################################################################################"
+
+ container run -n ${NAME} -- "apt update && apt ${YES} upgrade"
+
+ case "${FULL_UPGRADE}" in
+ true)
+ container run -n ${NAME} -- "apt update && ${YES} full-upgrade"
+ ;;
+ esac
+
+ case "${AUTOREMOVE}" in
+ true)
+ container run -n ${NAME} -- "apt ${YES} autoremove ${PURGE}"
+ ;;
+ esac
+
+ echo "'${NAME}': container updated."
+done
+
+# Post hooks
+for FILE in "${HOOKS}/post-${COMMAND}".* "${HOOKS}/${NAME}.post-${COMMAND}"
+do
+ if [ -x "${FILE}" ]
+ then
+ "${FILE}"
+ fi
+done